varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying highp vec3 v_uvlookup[5];

uniform sampler2D u_texture;

uniform float u_time;

float noise( in vec3 x )
{
    vec3 p = floor(x);
    vec3 f = fract(x);
	f = f*f*(3.0-2.0*f);
	
	vec2 uv = (p.xy+vec2(37.0,17.0)*p.z) + f.xy;
	vec2 rg = texture2D(u_texture, (uv+0.5)/256.0, -100.0 ).yx;
	return mix( rg.x, rg.y, f.z );
}

float noise_pre_5()
{
	float n = 0.0;
	float p = 0.5;
	for(int i=0; i<5; i++){

		vec2 rg = texture2D(u_texture, (v_uvlookup[i].xy+0.5)/256.0, -100.0 ).yx;
		n += p * mix( rg.x, rg.y, v_uvlookup[i].z );

		p *= .5;
	}

	return n;
}

float noise_5(in vec3 x){
	//acumulate
	float n = 0.0;
	n = .5 *noise(x);
	n += .25 *noise(x*2.1);
	n += .125 *noise(x*4.2);
	n += .0625 *noise(x*8.4);
	n += .03125 *noise(x*16.8);

	return n;
}

float noise_3(in vec3 x){
	//acumulate
	float n = 0.0;
	n = .5 *noise(x);
	n += .25 *noise(x*2.1);
	n += .125 *noise(x*4.2);

	return n;
}

void main() {
	float n = noise_pre_5();
	// float n = noise_5(vec3(v_texCoord, 0.0));
	gl_FragColor = v_color * n*n;
}
