attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
uniform highp mat4 u_modelViewProjectionMatrix;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying highp vec3 v_uvlookup[5];

uniform float u_time; 

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color;
	v_texCoord = a_texCoord;

	// get the noise lookup position
	float n=1.0;
	for(int i=0; i<5; i++){
		vec3 x = vec3(v_texCoord*1.5*n+.2*vec2(-u_time, u_time), u_time*float(i)*.2);
		vec3 p = floor(x);
	    vec3 f = fract(x);
		f.xy = f.xy*f.xy*(3.0-2.0*f.xy);
		
		v_uvlookup[i] = vec3((p.xy+vec2(37.0,17.0)*p.z) + f.xy, f.z);

		n *= 2.1;
	}
}