varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform float u_time;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

#define RES 256.0

float noise_iq_1D(in float t){//will work in a texture of RES period
    //mod to res
    float y = t/RES;
    float x = mod(t, RES);
    
    //based on iq noise, using manual blending so positions runs through u,v to
    //maximaize texture usage
    vec2 pA = floor(vec2(x, y));
    vec2 pB = floor(vec2(mod(x+1.0, RES), (x+1.0)/RES));
    vec2 f = fract(vec2(x, y));
	f = f*f*(3.0-2.0*f);
	
	//blend u top
    vec2 uvA = mod(pA+vec2(.5), RES);
    vec2 uvB = mod(pB+vec2(.5), RES);

    //get bilinear
	vec2 rgA = texture2D( u_texture1, uvA/RES, -100.0 ).yx;
    vec2 rgB = texture2D( u_texture1, uvB/RES, -100.0 ).yx;
    vec2 rg = mix(rgA, rgB, f.x);

	return mix( rg.x, rg.y, f.y );
}

float noise( in vec3 x ){
    vec3 p = floor(x);
    vec3 f = fract(x);
	f = f*f*(3.0-2.0*f);
	
	vec2 uv = (p.xy+vec2(37.0,17.0)*p.z) + f.xy;
	vec2 rg = texture2D( u_texture1, (uv+0.5)/256.0, -100.0 ).yx;
	return mix( rg.x, rg.y, f.z );
}

float noise_5(in vec3 x){
	//acumulate
	float n = 0.0;
	n = .5 *noise(x);
	n += .25 *noise(x*2.1);
	n += .125 *noise(x*4.2);
	n += .0625 *noise(x*8.4);
	n += .03125 *noise(x*16.8);

	return n;
}

float noise_3(in vec3 x){
	//acumulate
	float n = 0.0;
	n = .5 *noise(x);
	n += .25 *noise(x*2.1);
	n += .125 *noise(x*4.2);

	return n;
}

void main() {
	// gl_FragColor = v_color * texture2D(u_texture, v_texCoord);

	float t = u_time *.5;

	float n = noise_3(vec3(gl_FragCoord.xy*.05, t+noise_iq_1D(t)));

	n *=n*n*n;

	vec4 c = v_color * texture2D(u_texture, v_texCoord);

	gl_FragColor = vec4(c.xyz + n, c.a);
	//gl_FragColor = c;
}