varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform lowp float u_materialShininess;

const vec2 center = vec2(0.5, 0);
const vec2 down = vec2(0, -1);

void main()
{
    vec2 uv = vec2(v_texCoord.x, 1.0 - v_texCoord.y);
    vec2 uvPoint = normalize(uv - center);
    
    float rotAngle = u_materialShininess;
    mat2 rotMatrix = mat2(
        	cos(rotAngle), sin(rotAngle),
        	-sin(rotAngle), cos(rotAngle)
        );
    
    vec2 cutoffLine = down * rotMatrix;
    
    float cosAngle = dot(uvPoint, cutoffLine);
    vec4 color = texture2D(u_texture, v_texCoord);
	color.a *= smoothstep(0.0, 0.1, cosAngle);
    
	gl_FragColor = v_color * color;
}